# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class CollaborateChatGroupMessageEventTopicCollaborateChatEntity(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        CollaborateChatGroupMessageEventTopicCollaborateChatEntity - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'entity_jid': 'str',
            'entity_id': 'str',
            'entity_type': 'str'
        }

        self.attribute_map = {
            'entity_jid': 'entityJid',
            'entity_id': 'entityId',
            'entity_type': 'entityType'
        }

        self._entity_jid = None
        self._entity_id = None
        self._entity_type = None

    @property
    def entity_jid(self) -> str:
        """
        Gets the entity_jid of this CollaborateChatGroupMessageEventTopicCollaborateChatEntity.


        :return: The entity_jid of this CollaborateChatGroupMessageEventTopicCollaborateChatEntity.
        :rtype: str
        """
        return self._entity_jid

    @entity_jid.setter
    def entity_jid(self, entity_jid: str) -> None:
        """
        Sets the entity_jid of this CollaborateChatGroupMessageEventTopicCollaborateChatEntity.


        :param entity_jid: The entity_jid of this CollaborateChatGroupMessageEventTopicCollaborateChatEntity.
        :type: str
        """
        

        self._entity_jid = entity_jid

    @property
    def entity_id(self) -> str:
        """
        Gets the entity_id of this CollaborateChatGroupMessageEventTopicCollaborateChatEntity.


        :return: The entity_id of this CollaborateChatGroupMessageEventTopicCollaborateChatEntity.
        :rtype: str
        """
        return self._entity_id

    @entity_id.setter
    def entity_id(self, entity_id: str) -> None:
        """
        Sets the entity_id of this CollaborateChatGroupMessageEventTopicCollaborateChatEntity.


        :param entity_id: The entity_id of this CollaborateChatGroupMessageEventTopicCollaborateChatEntity.
        :type: str
        """
        

        self._entity_id = entity_id

    @property
    def entity_type(self) -> str:
        """
        Gets the entity_type of this CollaborateChatGroupMessageEventTopicCollaborateChatEntity.


        :return: The entity_type of this CollaborateChatGroupMessageEventTopicCollaborateChatEntity.
        :rtype: str
        """
        return self._entity_type

    @entity_type.setter
    def entity_type(self, entity_type: str) -> None:
        """
        Sets the entity_type of this CollaborateChatGroupMessageEventTopicCollaborateChatEntity.


        :param entity_type: The entity_type of this CollaborateChatGroupMessageEventTopicCollaborateChatEntity.
        :type: str
        """
        if isinstance(entity_type, int):
            entity_type = str(entity_type)
        allowed_values = ["Group", "User", "Adhoc"]
        if entity_type.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for entity_type -> " + entity_type)
            self._entity_type = "outdated_sdk_version"
        else:
            self._entity_type = entity_type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

