# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import AddressableEntityRef

class EventDefinitionAggregates(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        EventDefinitionAggregates - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'event_definition': 'AddressableEntityRef',
            'event_count': 'int'
        }

        self.attribute_map = {
            'event_definition': 'eventDefinition',
            'event_count': 'eventCount'
        }

        self._event_definition = None
        self._event_count = None

    @property
    def event_definition(self) -> 'AddressableEntityRef':
        """
        Gets the event_definition of this EventDefinitionAggregates.
        Event definition.

        :return: The event_definition of this EventDefinitionAggregates.
        :rtype: AddressableEntityRef
        """
        return self._event_definition

    @event_definition.setter
    def event_definition(self, event_definition: 'AddressableEntityRef') -> None:
        """
        Sets the event_definition of this EventDefinitionAggregates.
        Event definition.

        :param event_definition: The event_definition of this EventDefinitionAggregates.
        :type: AddressableEntityRef
        """
        

        self._event_definition = event_definition

    @property
    def event_count(self) -> int:
        """
        Gets the event_count of this EventDefinitionAggregates.
        How many events have occurred.

        :return: The event_count of this EventDefinitionAggregates.
        :rtype: int
        """
        return self._event_count

    @event_count.setter
    def event_count(self, event_count: int) -> None:
        """
        Sets the event_count of this EventDefinitionAggregates.
        How many events have occurred.

        :param event_count: The event_count of this EventDefinitionAggregates.
        :type: int
        """
        

        self._event_count = event_count

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

