# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import DataIngestionRules

class SocialTopicResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        SocialTopicResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'name': 'str',
            'description': 'str',
            'date_created': 'datetime',
            'date_modified': 'datetime',
            'division_id': 'str',
            'status': 'str',
            'data_ingestion_rules': 'DataIngestionRules',
            'self_uri': 'str'
        }

        self.attribute_map = {
            'id': 'id',
            'name': 'name',
            'description': 'description',
            'date_created': 'dateCreated',
            'date_modified': 'dateModified',
            'division_id': 'divisionId',
            'status': 'status',
            'data_ingestion_rules': 'dataIngestionRules',
            'self_uri': 'selfUri'
        }

        self._id = None
        self._name = None
        self._description = None
        self._date_created = None
        self._date_modified = None
        self._division_id = None
        self._status = None
        self._data_ingestion_rules = None
        self._self_uri = None

    @property
    def id(self) -> str:
        """
        Gets the id of this SocialTopicResponse.
        ID of the social topic.

        :return: The id of this SocialTopicResponse.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str) -> None:
        """
        Sets the id of this SocialTopicResponse.
        ID of the social topic.

        :param id: The id of this SocialTopicResponse.
        :type: str
        """
        

        self._id = id

    @property
    def name(self) -> str:
        """
        Gets the name of this SocialTopicResponse.
        The name of the social topic.

        :return: The name of this SocialTopicResponse.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str) -> None:
        """
        Sets the name of this SocialTopicResponse.
        The name of the social topic.

        :param name: The name of this SocialTopicResponse.
        :type: str
        """
        

        self._name = name

    @property
    def description(self) -> str:
        """
        Gets the description of this SocialTopicResponse.
        A description of the social topic.

        :return: The description of this SocialTopicResponse.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description: str) -> None:
        """
        Sets the description of this SocialTopicResponse.
        A description of the social topic.

        :param description: The description of this SocialTopicResponse.
        :type: str
        """
        

        self._description = description

    @property
    def date_created(self) -> datetime:
        """
        Gets the date_created of this SocialTopicResponse.
        Timestamp indicating when the social topic was created. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss[.mmm]Z

        :return: The date_created of this SocialTopicResponse.
        :rtype: datetime
        """
        return self._date_created

    @date_created.setter
    def date_created(self, date_created: datetime) -> None:
        """
        Sets the date_created of this SocialTopicResponse.
        Timestamp indicating when the social topic was created. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss[.mmm]Z

        :param date_created: The date_created of this SocialTopicResponse.
        :type: datetime
        """
        

        self._date_created = date_created

    @property
    def date_modified(self) -> datetime:
        """
        Gets the date_modified of this SocialTopicResponse.
        Timestamp indicating when the social topic was last updated. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss[.mmm]Z

        :return: The date_modified of this SocialTopicResponse.
        :rtype: datetime
        """
        return self._date_modified

    @date_modified.setter
    def date_modified(self, date_modified: datetime) -> None:
        """
        Sets the date_modified of this SocialTopicResponse.
        Timestamp indicating when the social topic was last updated. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss[.mmm]Z

        :param date_modified: The date_modified of this SocialTopicResponse.
        :type: datetime
        """
        

        self._date_modified = date_modified

    @property
    def division_id(self) -> str:
        """
        Gets the division_id of this SocialTopicResponse.
        The ID of the division to which the social topic belongs to.

        :return: The division_id of this SocialTopicResponse.
        :rtype: str
        """
        return self._division_id

    @division_id.setter
    def division_id(self, division_id: str) -> None:
        """
        Sets the division_id of this SocialTopicResponse.
        The ID of the division to which the social topic belongs to.

        :param division_id: The division_id of this SocialTopicResponse.
        :type: str
        """
        

        self._division_id = division_id

    @property
    def status(self) -> str:
        """
        Gets the status of this SocialTopicResponse.
        The status of the social topic.

        :return: The status of this SocialTopicResponse.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status: str) -> None:
        """
        Sets the status of this SocialTopicResponse.
        The status of the social topic.

        :param status: The status of this SocialTopicResponse.
        :type: str
        """
        if isinstance(status, int):
            status = str(status)
        allowed_values = ["Active", "Pending", "Deleted"]
        if status.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for status -> " + status)
            self._status = "outdated_sdk_version"
        else:
            self._status = status

    @property
    def data_ingestion_rules(self) -> 'DataIngestionRules':
        """
        Gets the data_ingestion_rules of this SocialTopicResponse.
        The data ingestion rules that apply to the social topic.

        :return: The data_ingestion_rules of this SocialTopicResponse.
        :rtype: DataIngestionRules
        """
        return self._data_ingestion_rules

    @data_ingestion_rules.setter
    def data_ingestion_rules(self, data_ingestion_rules: 'DataIngestionRules') -> None:
        """
        Sets the data_ingestion_rules of this SocialTopicResponse.
        The data ingestion rules that apply to the social topic.

        :param data_ingestion_rules: The data_ingestion_rules of this SocialTopicResponse.
        :type: DataIngestionRules
        """
        

        self._data_ingestion_rules = data_ingestion_rules

    @property
    def self_uri(self) -> str:
        """
        Gets the self_uri of this SocialTopicResponse.
        The URI for this object

        :return: The self_uri of this SocialTopicResponse.
        :rtype: str
        """
        return self._self_uri

    @self_uri.setter
    def self_uri(self, self_uri: str) -> None:
        """
        Sets the self_uri of this SocialTopicResponse.
        The URI for this object

        :param self_uri: The self_uri of this SocialTopicResponse.
        :type: str
        """
        

        self._self_uri = self_uri

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

