# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict

if TYPE_CHECKING:
    from . import WorkitemDateBasedCondition
    from . import WorkitemRuleAction
    from . import WorktypeReference

class WorkitemDateBasedRule(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        WorkitemDateBasedRule - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'name': 'str',
            'type': 'str',
            'action': 'WorkitemRuleAction',
            'worktype': 'WorktypeReference',
            'condition': 'WorkitemDateBasedCondition',
            'self_uri': 'str'
        }

        self.attribute_map = {
            'id': 'id',
            'name': 'name',
            'type': 'type',
            'action': 'action',
            'worktype': 'worktype',
            'condition': 'condition',
            'self_uri': 'selfUri'
        }

        self._id = None
        self._name = None
        self._type = None
        self._action = None
        self._worktype = None
        self._condition = None
        self._self_uri = None

    @property
    def id(self) -> str:
        """
        Gets the id of this WorkitemDateBasedRule.
        The globally unique identifier for the object.

        :return: The id of this WorkitemDateBasedRule.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str) -> None:
        """
        Sets the id of this WorkitemDateBasedRule.
        The globally unique identifier for the object.

        :param id: The id of this WorkitemDateBasedRule.
        :type: str
        """
        

        self._id = id

    @property
    def name(self) -> str:
        """
        Gets the name of this WorkitemDateBasedRule.


        :return: The name of this WorkitemDateBasedRule.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str) -> None:
        """
        Sets the name of this WorkitemDateBasedRule.


        :param name: The name of this WorkitemDateBasedRule.
        :type: str
        """
        

        self._name = name

    @property
    def type(self) -> str:
        """
        Gets the type of this WorkitemDateBasedRule.
        The type of the rule.

        :return: The type of this WorkitemDateBasedRule.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str) -> None:
        """
        Sets the type of this WorkitemDateBasedRule.
        The type of the rule.

        :param type: The type of this WorkitemDateBasedRule.
        :type: str
        """
        if isinstance(type, int):
            type = str(type)
        allowed_values = ["OnCreate", "OnAttributeChange", "Date"]
        if type.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for type -> " + type)
            self._type = "outdated_sdk_version"
        else:
            self._type = type

    @property
    def action(self) -> 'WorkitemRuleAction':
        """
        Gets the action of this WorkitemDateBasedRule.
        The rules action. If the condition criteria is met this action will be executed.

        :return: The action of this WorkitemDateBasedRule.
        :rtype: WorkitemRuleAction
        """
        return self._action

    @action.setter
    def action(self, action: 'WorkitemRuleAction') -> None:
        """
        Sets the action of this WorkitemDateBasedRule.
        The rules action. If the condition criteria is met this action will be executed.

        :param action: The action of this WorkitemDateBasedRule.
        :type: WorkitemRuleAction
        """
        

        self._action = action

    @property
    def worktype(self) -> 'WorktypeReference':
        """
        Gets the worktype of this WorkitemDateBasedRule.
        The Worktype containing the rule.

        :return: The worktype of this WorkitemDateBasedRule.
        :rtype: WorktypeReference
        """
        return self._worktype

    @worktype.setter
    def worktype(self, worktype: 'WorktypeReference') -> None:
        """
        Sets the worktype of this WorkitemDateBasedRule.
        The Worktype containing the rule.

        :param worktype: The worktype of this WorkitemDateBasedRule.
        :type: WorktypeReference
        """
        

        self._worktype = worktype

    @property
    def condition(self) -> 'WorkitemDateBasedCondition':
        """
        Gets the condition of this WorkitemDateBasedRule.
        The rules condition. If the condition criteria is met the rules action will be executed.

        :return: The condition of this WorkitemDateBasedRule.
        :rtype: WorkitemDateBasedCondition
        """
        return self._condition

    @condition.setter
    def condition(self, condition: 'WorkitemDateBasedCondition') -> None:
        """
        Sets the condition of this WorkitemDateBasedRule.
        The rules condition. If the condition criteria is met the rules action will be executed.

        :param condition: The condition of this WorkitemDateBasedRule.
        :type: WorkitemDateBasedCondition
        """
        

        self._condition = condition

    @property
    def self_uri(self) -> str:
        """
        Gets the self_uri of this WorkitemDateBasedRule.
        The URI for this object

        :return: The self_uri of this WorkitemDateBasedRule.
        :rtype: str
        """
        return self._self_uri

    @self_uri.setter
    def self_uri(self, self_uri: str) -> None:
        """
        Sets the self_uri of this WorkitemDateBasedRule.
        The URI for this object

        :param self_uri: The self_uri of this WorkitemDateBasedRule.
        :type: str
        """
        

        self._self_uri = self_uri

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

